//SE RECOMIENDA USAR ESTE PROGRAMA CON LA VERSION MPLAB IDE V.8.63 Y COMPILADOR C18 V3.40
//ESTE PROGRAMA USA EL COMPILADOR C18. EL ARCHIVO (.HEX) RESULTANTE DE LA COMPILACION 
//DEBE CARGARSE EN LA TARJETA BOLT DESDE LA PC CON EL SOFTWARE BOOTLOADER "Bolt 1.0.1"
//ES INDISPENSABLE INTEGRAR EN EL PROYECTO DE MPLAB EL ARCHIVO "rm18f2550.lkr" QUE ES UN 
//SCRIPT PARA EL LINKER DEL C18.TAMBIN SE DEBE INCLUIR EN EL PROYECTO LA LIBRERA UNIVERSAL 
//"18F2550BOLT". LAS LIBRERIAS ADICIONALES Y ARCHIVOS COMPLETOS QUE USTED PUEDE NECESITAR PARA 
//SU PROYECTO LOS ENCONTRARA EN EL ARCHIVO "C18-PLANTILLAS-LIBRERIAS-BOLT.ZIP"
//Genera un nmero aleatorio del 00 al 42 y lo muestra en la matriz doble 7x10.El nmero 
//aleatorio se genera a partir de una "semilla"  "seed". El "seed" depende de un contador 
//interno de 0...255, que se incrementa cada microsegundo (aprox.) y se guarda en la 
//localidad 0x80.Cuando el usuario oprime el botn de reset,el valor de la variable "seed"
//ser un nmero aleatorio,debido a que el tiempo que demora en oprimir el botn de reset
//siempre es distinto.Si se quiere cambiar el nmero aleatorio mximo,en la lnea "rana=seed/6" 
//modifique el 6. El nmero mximo es 255/x. 

#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"


extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code

int i,k,qu;
int seed;
int rana,zeta,mar;					//variable ndice malla principal 					//variable ndice para arreglo pf[]
#pragma udata seed=0x80					//RESERVA LOCALIDAD PARA VARIABLE seed 
int jota=0;				//variable indice para arreglo pf[]
char matrix[]="00";		//string con texto
char pf[10]; 
#include "LETRASCCS2.h"
void main()
{
init_bolt();
seed=seed&0x00FF;				//deja nicamente 8 bits menos significativos
rana=seed/6;				//genera nmero aleatorio de 0...42
malla:
PORTB=0;
mar=atoi(matrix);	
if(mar==rana)goto sigue;
mar=mar+1;			
if(mar<10)
{matrix[1]++;goto sigue;}
if(mar==100)
{matrix[0]='0';matrix[1]='0';goto sigue;}
sprintf(matrix,"%d",mar);
sigue:	
jota=0;
for(k=0;k<2;k++)
{swatch(matrix[k]);}	//acomoda patrn de columnas
   for(zeta=0;zeta<4;zeta++)	//malla controla retraso entre nmeros
   {
   i=0;        	  //Inicializamos el contador auxiliar.
   PORTA=0x00;    //Inicializamos el Puerto A   
   RA1=1;                     //Reset al contador    
   RA1=0;                     //
   	  for(i=0;i<10;i++)    	  //El valor de la columna 0
   	  {                       //las 10 columnas
      PORTB=pf[i];             //Mostramos el valor de la columna
		for(qu=0;qu<200;qu++)
		{seed++;}				  //modifica nmero aleatorio
	  delay_us(100);			  				//mantiene seal en PORTB durante 1 ms.
	  RA2=1;                  //Incrementa el contador            
      RA2=0; 
      PORTB=0X00;			  //evita que seal pase a siguiente columna                          
      }	
   }
goto malla;					
}


