//SE RECOMIENDA USAR ESTE PROGRAMA CON LA VERSION MPLAB IDE V.8.63 Y COMPILADOR C18 V3.40
//ESTE PROGRAMA USA EL COMPILADOR C18. EL ARCHIVO (.HEX) RESULTANTE DE LA COMPILACION 
//DEBE CARGARSE EN LA TARJETA BOLT DESDE LA PC CON EL SOFTWARE BOOTLOADER "bolt 1.0.1"
//ES INDISPENSABLE INTEGRAR EN EL PROYECTO DE MPLAB EL ARCHIVO "rm18f2550.lkr" QUE ES UN 
//SCRIPT PARA EL LINKER DEL C18.TAMBIN SE RECOMIENDA INCLUIR EN EL PROYECTO
//LA LIBRERA UNIVERSAL "18F2550BOLT". LAS LIBRERIAS ADICIONALES Y ARCHIVOS COMPLETOS QUE 
//USTED PUEDE NECESITAR PARA SU PROYECTO LOS ENCONTRARA EN EL ARCHIVO 
//"C18-PLANTILLAS-LIBRERIAS-BOLT.ZIP"
//PROGRAMA PARA EL MODULO DE 7X10 MATRIZ DE LEDS.MUESTRA CARACTERES GRAFICOS CORAZON Y FLECHA.
//PUEDEN TAMBIEN MOSTRARSE 2 CARACTERES DE TEXTO.

#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code
int i;					//variable ndice malla principal 
int k;					//variable ndice para arreglo pf[]
int jota=0;				//variable indice para arreglo pf[]
char matrix[]="/(";		//string con texto (flecha). "%&" para corazn.
char pf[10]; 
#include "LETRASCCS2.h"
void main()
{
init_bolt();
for(k=0;k<2;k++)
{swatch(matrix[k]);}	//acomoda patrn de columnas
   while(1)			//malla principal
   {
   i=0;        	  //Inicializamos el contador auxiliar.
   PORTA=0x00;    //Inicializamos el Puerto A   
   RA1=1;                     //Reset al contador
   delay_us(10);          
   RA1=0;                     //
   	  for(i=0;i<10;i++)    	  //El valor de la columna 0 ya est en el puerto as que solo vamos a barrer
   	  {                       //las 10 columnas
      PORTB=pf[i];             //Mostramos el valor de la columna
	  delay_ms(2);
	  RA2=1;                  //Incrementa el contador
      delay_us(10);            
      RA2=0;                  
      delay_us(10);             
      }
   }           					
}